<template>
  <div>
    <h1 class="mb-6">What do you think is the most likely reason for your ED?</h1>
    <div class="space-y-3 mb-5">
      <radio-input
        v-for="choice in choices"
        :key="choice.value"
        v-model="selected.value"
        :has-free-answer="choice.freeAnswer"
        :text-value="selected.freeAnswer"
        :input-value="choice.value"
        @textInput="text => selected.freeAnswer = text"
      >
        {{ choice.value }}
      </radio-input>
    </div>
    <CommonBtn
      text="Save and continue"
      @click="$emit('nextStage')"
      :disabled="!selected.value"
      v-if="selected.value"
    />
  </div>
</template>

<script>
import RadioInput from "@/components/inputs/RadioInput";
import CommonBtn from "@/components/common/CommonBtn";
import {answersMixin} from "@/utils/mixins";

const OTHER = 'Other'

export default {
  mixins: [answersMixin],
  name: "YourHealth2",
  components: {CommonBtn, RadioInput},
  watch: {
    'selected.value'() {
      this.selected.freeAnswer = null
    },
    selected: {
      handler(newVal) {
        let answerVal = ''
        if (newVal.value === OTHER) {
          answerVal = `Other: ${newVal.freeAnswer}`
        } else {
          answerVal = newVal.value
        }
        this.setAnswer(this.answersKeys.YOUR_HEALTH, answerVal, 'stage_2')
        this.$emit('nextStage')
      },
      deep: true
    },
  },
  data() {
    return {
      selected: {
        freeAnswer: null,
        value: null,
      },
      choices: [
        {value: 'Medical illness or surgery'},
        {value: 'Prescription medications'},
        {value: 'Stress or relationship problems'},
        {value: 'I don\'t know'},
        {value: OTHER, freeAnswer: true},
      ],
    }
  },
}
</script>

<style scoped>

</style>
